Adaptive Huffman Coding
=======================

Implemented algorithms:
-----------------------
1. FGK algorithm
2. Vitter's algorithm

Executable JAR:
---------------
An executable jar is enclosed to the project. By default it uses string "this is a test message" as messasge to be encoded and then decoded by the Vitter's algorithm. Otherwise one may specify two program arguments, first one determines the algorithm and the second one is the message. The execution command is of the form: 

java -jar adaptivehuffman.jar <"vitter" or "fgk"> <message>

e.g. java -jar adaptivehuffman.jar vitter "vitter test message"

Package overview:
----------------
* cz.cvut.fel.tik.adaptivehuffman - *base* package, contains prtoject's main class
* *base*.encoder - contains encoder interface and implementation (both algorithms)
* *base*.decoder - contains decoder interface and implementation (both algorithms)
* *base*.factory - contains factory classes for creating appropriate encoder and decoder
* *base*.tree - contains data structures related to the coding tree used in algorithms

Repository:
-----------
Project is publicly available at [bitbucket](https://bitbucket.org/matyama/adaptivehuffman).

Resources:
----------
Resources that were used in order to study the problem and implement algorithms are listed below:
* [Data Compression](http://www.ics.uci.edu/~dan/pubs/DC-Sec4.html)
* [Adaptive Huffman Coding](http://www.cs.duke.edu/csed/curious/compression/adaptivehuff.html#tree)
* [Adaptive Huffman coding Vitter's algorithm](http://www.stringology.org/DataCompression/ahv/index_en.html)
* [Adaptive Huffman coding DFK](http://www.stringology.org/DataCompression/fgk/index_en.html)
* [wikipedia](http://en.wikipedia.org/wiki/Huffman_coding)

