package cz.cvut.fel.tik.adaptivehuffman.decoder;

import cz.cvut.fel.tik.adaptivehuffman.tree.*;

public class FGKDecoder implements Decoder {
	
	private Tree tree = new FGKTree();
	
	@Override
	public String decode(String code) {
		String decoded = "";
		String temp = "";
		for(int i = 0; i < code.length(); ){
			//charTree.printSymbolHash();
			char c = tree.decodeLeaf(temp);
			if(c != FGKTree.NULL) {
				if(c == FGKTree.NYT)
				{
					char nchar  = tree.addNewChar(code.substring(i, i+8));
					i += 8;
					decoded += nchar;
				} else 
				{
					decoded += c;
				}
				//System.out.println(temp);
				temp = "";
			}
			if(i < code.length())temp += code.charAt(i++);
		}
		if(temp != "") decoded += tree.decodeLeaf(temp);
		return decoded;
	}

}
