package cz.cvut.fel.tik.adaptivehuffman.tree;

public interface Tree {

	public static final char NYT = '#';
	
	public static final char NULL = '@';
	
	public String getBitValueOf(char c);
	
	public char decodeLeaf(String message);
	
	public char addNewChar(String substring);
	
	public class Node {
		
		public char symbol;
		public int value;
		public int id;
		public int level;
		
		public String getBit;
		
		public Node left = null;
		public Node right = null;
		public Node parent = null;
		
		public Node(char symbol) {
			this(symbol, 0, 0, 0, "");
		}
		
		public Node(char symbol, int value, int id, int level, String getBit) {
			this(symbol, value, id, level, getBit, null, null, null);
		}
		
		public Node(char symbol, int value, int id, int level, String getBit, Node parent) {
			this(symbol, value, id, level, getBit, null, null, parent);
		}
		
		public Node(char symbol, int value, int id, int level, String getBit, Node left, Node right, Node parent) {
			super();
			this.symbol = symbol;
			this.value = value;
			this.id = id;
			this.level = level;
			this.getBit = getBit;
			this.left = left;
			this.right = right;
		}
		
		public boolean isRoot() {
			return parent == null;
		}
		
		public boolean isLeaf() {
			return (left == null && right == null);
		}
	}
	
}
